//
// Copyright (C) 1999-2004 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#include <WScom.h>
#include <WSCRvtimer.h>
#include <WSCbase.h>
#include <WSCbaseList.h>
#include <WSCvtimer.h>

WSMFclassInit(WSCRvtimer,WSCRngbase);
WSMFremoteClassInit(WSCRvtimer,WSCvtimer);

WSCRvtimer::WSCRvtimer(){
}

WSCRvtimer::~WSCRvtimer(){
}

void WSCRvtimer::onActivate(){
  if (_local != NULL){
    WSCvtimer* item = (WSCvtimer*)_local->cast("WSCvtimer");
    if (item != NULL){
      item->onActivate();
      return;
    }
  }
  WSCremoteCall rc;
  rc.setClassName("WSCvtimer");
  rc.setOperationName("onActivate");
  beginRemoteCall(&rc);
  if (_db == NULL){
    return;
  } 
  endRemoteCall();
}

void _WSCvtimer_remote_call(WSDserialize* db,WSCremoteCall* rc){
  if ( rc->_op[0] == 'o'){
    if (!strcmp(rc->_op,"onActivate")){
      WSCbase* inst = WSGIappObjectList()->getInstance(rc->_class,rc->_instance);
      if (inst != NULL){
        WSCvtimer* item = (WSCvtimer*)inst->cast("WSCvtimer");
        if (item != NULL){
          item->onActivate();
        }
      }
      return;
    }
  }
extern void _WSCngbase_remote_call(WSDserialize* db,WSCremoteCall* rc);
  _WSCngbase_remote_call(db,rc);
}

WSMFdefineDrNetServer(WSCvtimer,_WSCvtimer_remote_call);

